{LCD_Game.spin
Paul A. Willoughby, DVM
1/22/2012

}
CON
        _clkmode = xtal1 + pll16x                      
        _xinfreq = 5_000_000             '80MHz

        _rxPin = 8         'using serial com
        _txPin = 9
       
        
   

VAR
       long ud, lr
       byte player_row, player_col
       byte opponent_row
       byte opponent_col
       byte delay

               
OBJ
  LCD         : "FullDuplexSerial"
  rc1         : "RCTime"
  rc2         : "RCTime"
  RandGen     : "RealRandom"

PUB Main   
  
   Init

   repeat 
      opponent_row := ((RandGen.random >> 1) // 4) + 1
      repeat  opponent_col from 1 to 19
      
          if opponent_col == (player_col-1) and opponent_row == player_row
             player_col++
          elseif opponent_col == player_col and opponent_row == player_row
             player_col++
          else
              GetPlayerCol 
          GetPlayerRow               
          MoveTo(opponent_col, opponent_row)
          LCD.STR(string("-B"))
          MoveTo(player_col, player_row)
          LCD.STR(string("*"))
          waitcnt(clkfreq / delay + cnt)
          Clear
          if opponent_col == 1 and player_col == 20
             delay := 5                   
          if player_col ==1
             delay++
             
PUB GetPlayerCol             

    if ud >120
      player_col--
    if ud <40
      player_col++    
    if player_col >20
      player_col := 20
    if player_col < 1
      player_col := 19

PUB GetPlayerRow              

    if lr > 120
      player_row--
    if lr < 40
      player_row++
    if player_row >4
      player_row := 4
    if player_row < 1
      player_row := 1
  
PUB MoveTo (x, y)

      LCD.tx($fe)
      LCD.tx($47)
      LCD.tx(x)
      LCD.tx(y)

PUB Clear
      LCD.tx($fe)
      LCD.tx($58)    'clear screen


Pub  Init

      LCD.start(_rxPin, _txPin, 0, 19_200)
      RandGen.start 
      waitcnt(clkfreq /2 + cnt)
      Clear
      rc1.start(4, 1, @lr)
      rc2.start(2, 1, @ud)
      player_row := 4
      player_col := 20
      delay := 5